package main

import "time"
import "math/rand"

const min1, max1, min2, max2 int = 1, 10, 1000, 1015

// show send, receive, select
func Gen(min int, max int) chan int {
	c := make(chan int)
	go Genc(c, min, max)
	return c
}

func Genc(c chan int, min int, max int) {
	for i := min; i <= max; i++ {
		c <- i
		time.Sleep(time.Duration(rand.Intn(5e2)) * time.Millisecond)
	}
}

func main() {
	c1 := Gen(min1, max1)
	c2 := Gen(min2, max2)
	i := 0
	for i < (1+max1-min1)+(1+max2-min2) {
		select {
		case m := <-c2:
			println("got", m, "from c2")
			i++
		case n := <-c1:
			println("got", n, "from c1")
			i++
		default:
			println("Waiting...")
			time.Sleep(time.Duration(rand.Intn(1e2)) * time.Millisecond)
		}
	}
	println("Bye!")
}
